local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB

local CURRENT_PAGE = 0
local MAX_PAGE = 5

SLASH_TOHR1, SLASH_TOHR2, SLASH_TOHR3 = '/tui', '/tohr', '/tohrui';
function SlashCmdList.TOHR(msg, editbox)
	if msg == 'help' then
		 print('|cffffff00Tohr UI |cffffffffusage:');
		 print('/tui');
		 print('/tui reset');
		 print('/tui install');
		 print('/tui options');
	elseif msg == 'reset' then
		E:ResetUI()
	elseif msg == 'install' then
		E:Install();
	elseif msg == 'options' then
		E:Install();
	else
		E:Install();
	end
end


Tohr_Version = GetAddOnMetadata("ElvUI_TohrUI", "Version");
Tohr_Title = GetAddOnMetadata("ElvUI_TohrUI", "Title");

L["LOGIN_MSG"] = ""..Tohr_Title.." |cff00FF96v"..Tohr_Version.." |cffffffffhas been fully loaded. Type |cffFF4500/tui|cffffffff, |cffFF4500/tohr|cffffffff, or |cffFF4500/tohrui |cffffffffto apply any changes"

local function SetupChat()
	InstallStepComplete.message = L["Chat Set"]
	InstallStepComplete:Show()			
	FCF_ResetChatWindows()
	FCF_SetLocked(ChatFrame1, 1)
	FCF_DockFrame(ChatFrame2)
	FCF_SetLocked(ChatFrame2, 1)	
	FCF_OpenNewWindow(Chat)
	FCF_SetLocked(ChatFrame3, 1)
	ChatFrame3:Show()
			
	for i = 1, NUM_CHAT_WINDOWS do
		local frame = _G[format("ChatFrame%s", i)]
		local chatFrameId = frame:GetID()
		local chatName = FCF_GetChatWindowInfo(chatFrameId)
				
		FCF_SavePositionAndDimensions(frame)
		FCF_StopDragging(frame)
		
		-- set default Elvui font size
		FCF_SetChatWindowFontSize(nil, frame, 12, "OUTLINE")
		
		-- rename windows general because moved to chat #3
		if i == 1 then
			FCF_SetWindowName(frame, GENERAL)
		elseif i == 2 then
			FCF_SetWindowName(frame, GUILD_EVENT_LOG)
		elseif i == 3 then
			FCF_SetWindowName(frame, "Chat")
		end
	end
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame1)
	ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_INLINE_TOAST_ALERT")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_HORDE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_ALLIANCE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_NEUTRAL")
	ChatFrame_AddMessageGroup(ChatFrame1, "SYSTEM")
	ChatFrame_AddMessageGroup(ChatFrame1, "AFK")
	ChatFrame_AddMessageGroup(ChatFrame1, "DND")
	ChatFrame_AddMessageGroup(ChatFrame1, "IGNORED")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "CHANNEL")	
	ChatFrame_AddMessageGroup(ChatFrame1, "EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BOSS_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "ERRORS")
	ChatFrame_AddMessageGroup(ChatFrame1, "LOOT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONEY")
	ChatFrame_AddMessageGroup(ChatFrame1, "SKILL")
	ChatFrame_AddMessageGroup(ChatFrame1, "CURRENCY ")
	ChatFrame_AddMessageGroup(ChatFrame1, "COMBAT_XP_GAIN")
	ChatFrame_RemoveChannel(ChatFrame1, L['LocalDefense'])
	ChatFrame_RemoveChannel(ChatFrame1, L['LookingForGroup'])
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame3)
	ChatFrame_AddMessageGroup(ChatFrame3, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame3, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame3, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame3, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame3, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame3, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame3, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame3, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame3, "BN_CONVERSATION")
	ChatFrame_RemoveMessageGroup(ChatFrame3, "BN_INLINE_TOAST_ALERT")
	ChatFrame_RemoveMessageGroup(ChatFrame3, "CHANNEL")	

	-- enable classcolor automatically on login and on each character without doing /configure each time.
	ToggleChatColorNamesByClassGroup(true, "SAY")
	ToggleChatColorNamesByClassGroup(true, "EMOTE")
	ToggleChatColorNamesByClassGroup(true, "YELL")
	ToggleChatColorNamesByClassGroup(true, "GUILD")
	ToggleChatColorNamesByClassGroup(true, "OFFICER")
	ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "WHISPER")
	ToggleChatColorNamesByClassGroup(true, "PARTY")
	ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID")
	ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
	ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT")	
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT_LEADER")	
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL6")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL7")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL8")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL9")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL10")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	
	--Adjust Chat Colors
	--General
	ChangeChatColor("CHANNEL1", 195/255, 230/255, 232/255)
	--Trade
	ChangeChatColor("CHANNEL2", 232/255, 158/255, 121/255)
	--Local Defense
	ChangeChatColor("CHANNEL3", 232/255, 228/255, 121/255)
end

local function SetupCVars()
	SetCVar("alternateResourceText", 1)
	SetCVar("alwaysShowActionBars", 1)
	SetCVar("chatMouseScroll", 1)
	SetCVar("chatStyle", "classic")
	SetCVar("conversationMode", "inline")
	SetCVar('lockActionBars', 1)
	SetCVar("screenshotQuality", 10)
	SetCVar("ShowClassColorInNameplate", 1)
	SetCVar("showTutorials", 0)
	SetCVar('SpamFilter', 0)
	SetCVar("statusTextDisplay", "BOTH")
	SetCVar("threatWarning", 3)
	SetCVar("UberTooltips", 1)
	SetCVar("wholeChatWindowClickable", 0)
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:SetValue('CTRL')
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:RefreshValue()
	InstallStepComplete.message = L["CVars Set"]
	InstallStepComplete:Show()					
end	

function E:GetColor(r, b, g, a)	
	return { r = r, b = b, g = g, a = a }
end

function E:SetupTheme(theme, noDisplayMsg)
	local classColor = RAID_CLASS_COLORS[E.myclass]
	E.private.theme = theme
	if not E.db.movers then E.db.movers = {}; end
		if theme == "TohrUI" then
		InstallStepComplete.message = L["TohrUI Installed"]
		InstallStepComplete:Show()
	-- Movers
		E.db.movers["ElvUF_FocusCastbarMover"] = "TOPElvUIParentTOP0-24"
		E.db.movers["ElvUF_PlayerCastbarMover"] = "BOTTOMElvUIParentBOTTOM0402"
		E.db.movers["LeftChatMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT2526"
		E.db.movers["GMMover"] = "TOPRIGHTElvUIParentTOPRIGHT-436-24"
		E.db.movers["BuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-24-24"
		E.db.movers["BossButton"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT116280"
		E.db.movers["LootFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-480-122"
		E.db.movers["ElvUF_RaidpetMover"] = "TOPLEFTElvUIParentBOTTOMLEFT1496188"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOMElvUIParentBOTTOM170356"
		E.db.movers["MicrobarMover"] = "TOPElvUIParentTOP0-24"
		E.db.movers["VehicleSeatMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT308249"
		E.db.movers["ExperienceBarMover"] = "TOPLEFTElvUIParentTOPLEFT25-174"
		E.db.movers["ElvUF_AssistMover"] = "TOPElvUIParentTOP-301-4"
		E.db.movers["ElvUF_TargetTargetMover"] = "BOTTOMElvUIParentBOTTOM244509"
		E.db.movers["LossControlMover"] = "TOPElvUIParentTOP0-400"
		E.db.movers["ElvUF_Raid40Mover"] = "TOPLEFTElvUIParentBOTTOMLEFT1504274"
		E.db.movers["ElvUF_TargetMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-410504"
		E.db.movers["RightChatMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-2526"
		E.db.movers["ElvAB_1"] = "BOTTOMElvUIParentBOTTOM053"
		E.db.movers["ElvAB_2"] = "BOTTOMElvUIParentBOTTOM024"
		E.db.movers["WatchFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-143-206"
		E.db.movers["ElvUF_PlayerMover"] = "BOTTOMElvUIParentBOTTOM0356"
		E.db.movers["ElvAB_4"] = "BOTTOMElvUIParentBOTTOM0111"
		E.db.movers["CM_MOVER"] = "BOTTOMElvUIParentBOTTOM0389"
		E.db.movers["AltPowerBarMover"] = "TOPElvUIParentTOP0-174"
		E.db.movers["ElvAB_3"] = "BOTTOMElvUIParentBOTTOM082"
		E.db.movers["ElvAB_5"] = "BOTTOMElvUIParentBOTTOM0320"
		E.db.movers["PlayerPowerBarMover"] = "BOTTOMElvUIParentBOTTOM0413"
		E.db.movers["ElvAB_6"] = "TOPElvUIParentTOP0-24"
		E.db.movers["ArenaHeaderMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-66396"
		E.db.movers["ObjectiveFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-78-192"
		E.db.movers["BNETMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT51224"
		E.db.movers["ShiftAB"] = "TOPLEFTElvUIParentTOPLEFT23-181"
		E.db.movers["PetAB"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-24389"
		E.db.movers["ReputationBarMover"] = "TOPLEFTElvUIParentTOPLEFT25-174"
		E.db.movers["ElvUF_TargetCastbarMover"] = "BOTTOMElvUIParentBOTTOM0514"
		E.db.movers["TooltipMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-452116"
		E.db.movers["ElvUF_TankMover"] = "TOPElvUIParentTOP-302-4"
		E.db.movers["BossHeaderMover"] = "TOPLEFTElvUIParentTOPLEFT25-218"
		E.db.movers["ElvUF_PetMover"] = "BOTTOMElvUIParentBOTTOM-170356"
		E.db.movers["TotemBarMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT43866"
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT1095150"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT189426"
		E.db.movers["AlertFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-480-122"
		E.db.movers["DebuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-24-126"
		E.db.movers["MinimapMover"] = "TOPLEFTElvUIParentTOPLEFT24-24"
		E.db.movers["ElvUF_BodyGuardMover"] = "BOTTOMElvUIParentBOTTOM-170322"
		
		E.db.bagsOffsetFixed = true
		E.db.hideTutorial = true
	-- General
		E.db.general.loginmessage = true
		E.db.general.normTex = "ElvUI Norm"
		E.db.general.glossTex = "Tohr_Texture"
		E.db.general.dmgfont = "Jacinto Sans"
		E.db.general.namefont = "Roboto-Black"
		E.db.general.autoAcceptInvite = false
		E.db.general.font = "Roboto-Black"
		E.db.general.topPanel = false
		E.db.general.bottomPanel = false
		E.db.general.fontSize = 10
		E.db.general.minimap.size = 146
		E.db.general.minimap.icons.garrison.xOffset = 0
		E.db.general.minimap.icons.garrison.yOffset = 0
		E.db.general.minimap.icons.garrison.position = "BOTTOMLEFT"
		E.db.general.experience.width = 167
		E.db.general.experience.height = 8
		E.db.general.experience.mouseover = false
		E.db.general.experience.orientation = "HORIZONTAL"
		E.db.general.experience.textFormat = "PERCENT"
		E.db.general.experience.textSize = 12
		E.db.general.reputation.width = 167
		E.db.general.reputation.height = 8
		E.db.general.reputation.mouseover = false
		E.db.general.reputation.orientation = "HORIZONTAL"
		E.db.general.reputation.textFormat = "NONE"
		E.db.general.reputation.textSize = 12
		E.db.general.threat.enable = false
		E.db.general.backdropcolor = { r = 40/255,g = 40/255,b = 40/255 }
		E.db.general.backdropfadecolor = { r = 10/255,g = 10/255,b = 10/255, a = 0.65}
		E.db.general.valuecolor = E:GetColor(classColor.r, classColor.b, classColor.g)
		E.db.general.totems.enable = true
		E.db.general.totems.growthDirection = "VERTICAL"
		E.db.general.vendorGrays = true
		E.db.general.autoRepair = "GUILD"
	--Unit Frames
		E.db.unitframe.statusbar = "Tohr_Texture"
		E.db.unitframe.font = "Roboto-Black"
		E.db.unitframe.fontSize = 9
		E.db.unitframe.fontOutline = "OUTLINE"
		E.db.unitframe.debuffHighlighting = false
		E.db.unitframe.smoothbars = true
		E.db.unitframe.smartRaidFilter = false
	--Colors
		E.db.unitframe.colors.healthclass = false
		E.db.unitframe.colors.powerclass = true
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.colors.transparentHealth = true
		E.db.unitframe.colors.classbackdrop = true
		E.db.unitframe.colors.health = { r = 0/255, g = 0/255, b = 0/255 }
		E.db.unitframe.colors.health_backdrop = { r = 0/255,g = 0/255,b = 0/255 }
		E.db.unitframe.colors.tapped = { r = 231/255, g = 241/255, b = 255/255 }
		E.db.unitframe.colors.disconnected = { r = 255/255, g = 210/255, b = 158/255 }
		E.db.unitframe.colors.power.MANA = { r = 79/255,g = 115/255,b = 161/255 }
		E.db.unitframe.colors.power.RAGE = { r = 199/255,g = 64/255,b = 64/255 }
		E.db.unitframe.colors.power.FOCUS = { r = 181/255,g = 110/255,b = 69/255 }
		E.db.unitframe.colors.power.ENERGY = { r = 255/255,g = 234/255,b = 0/255 }
		E.db.unitframe.colors.power.RUNIC_POWER = { r = 0/255,g = 209/255,b = 255/255 }
		E.db.unitframe.colors.reaction.BAD = { r = 199/225, g = 64/225, b = 64/225 }
		E.db.unitframe.colors.reaction.NEUTRAL = { r = 218/255, g = 197/255, b = 92/255 }
		E.db.unitframe.colors.reaction.GOOD = { r = 75/255, g = 175/255, b = 76/255 }
		E.db.unitframe.colors.castColor = { r = 80/255, g = 80/255, b = 80/255 }
		E.db.unitframe.colors.castNoInterrupt = { r = 190/255, g = 60/255, b = 60/255 }
		E.db.unitframe.colors.castClassColor = false
		E.db.unitframe.colors.transparentCastbar = false
		E.db.unitframe.colors.customhealthbackdrop = false
		E.db.unitframe.colors.colorhealthbyvalue = false
	--Player
		E.db.unitframe.units.player.customTexts = {}
		E.db.unitframe.units.player.restIcon = true
		E.db.unitframe.units.player.width = 270
		E.db.unitframe.units.player.height = 30
		E.db.unitframe.units.player.healPrediction = false
		E.db.unitframe.units.player.threatStyle = "NONE"
		E.db.unitframe.units.player.health.text_format = "[health:current]"
		E.db.unitframe.units.player.health.xOffset = 0
		E.db.unitframe.units.player.health.yOffset = 0
		E.db.unitframe.units.player.health.position = "LEFT"
		E.db.unitframe.units.player.power.text_format = "[power:current]"
		E.db.unitframe.units.player.power.height = 16
		E.db.unitframe.units.player.power.yOffset = 0
		E.db.unitframe.units.player.power.xOffset = 4
		E.db.unitframe.units.player.power.attachTextToPower = false
		E.db.unitframe.units.player.power.position = "RIGHT"
		E.db.unitframe.units.player.power.detachFromFrame = false
		E.db.unitframe.units.player.pvp.text_format = "|cFFB04F4F[pvptimer]|r"
		E.db.unitframe.units.player.buffs.enable = false
		E.db.unitframe.units.player.buffs.attachTo = "FRAME"
		E.db.unitframe.units.player.debuffs.enable = true
		E.db.unitframe.units.player.debuffs.sizeOverride = 48
		E.db.unitframe.units.player.debuffs.xOffset = -77
		E.db.unitframe.units.player.debuffs.yOffset = 144
		E.db.unitframe.units.player.debuffs.fontSize = 20
		E.db.unitframe.units.player.debuffs.attachTo = "Frame"
		E.db.unitframe.units.player.debuffs.anchorPoint = "LEFT"
		E.db.unitframe.units.player.debuffs.perrow = 6
		E.db.unitframe.units.player.debuffs.useFilter = "Blacklist"
		E.db.unitframe.units.player.debuffs.spacing = 2
		E.db.unitframe.units.player.castbar.enable = true
		E.db.unitframe.units.player.castbar.width = 270
		E.db.unitframe.units.player.castbar.height = 20
		E.db.unitframe.units.player.castbar.icon = true
		E.db.unitframe.units.player.castbar.latency = true
		E.db.unitframe.units.player.castbar.format = "Remaining"
		E.db.unitframe.units.player.castbar.ticks = true
		E.db.unitframe.units.player.castbar.spark = true
		E.db.unitframe.units.player.classbar.enable = true
		E.db.unitframe.units.player.classbar.detachFromFrame = true
		E.db.unitframe.units.player.classbar.fill = "spaced"
		E.db.unitframe.units.player.classbar.detachedWidth = 270
		E.db.unitframe.units.player.classbar.height = 10
		E.db.unitframe.units.player.aurabar.enable = false
		E.db.unitframe.units.player.aurabar.attachTo = "BUFFS"
		E.db.unitframe.units.player.aurabar.height = 22
		E.db.unitframe.units.player.aurabar.anchorPoint = "BELOW"
		E.db.unitframe.units.player.stagger.enable = false
	--Target
		E.db.unitframe.units.target.rangeCheck = true
		E.db.unitframe.units.target.width = 270
		E.db.unitframe.units.target.height = 35
		E.db.unitframe.units.target.healPrediction = false
		E.db.unitframe.units.target.threatStyle = "NONE"
		E.db.unitframe.units.target.health.text_format = "[health:percent]"
		E.db.unitframe.units.target.health.position = "TOPRIGHT"
		E.db.unitframe.units.target.health.xOffset = 6
		E.db.unitframe.units.target.health.yOffset = 6
		E.db.unitframe.units.target.power.height = 10
		E.db.unitframe.units.target.power.width = "spaced"
		E.db.unitframe.units.target.power.attachTextToPower = true
		E.db.unitframe.units.target.power.detachedWidth = 200
		E.db.unitframe.units.target.power.text_format = "[power:current]"
		E.db.unitframe.units.target.power.yOffset = 2
		E.db.unitframe.units.target.power.hideonnpc = false
		E.db.unitframe.units.target.power.position = "LEFT"
		E.db.unitframe.units.target.name.position = "TOPLEFT"
		E.db.unitframe.units.target.name.text_format = "[namecolor][name:medium] [difficultycolor][smartlevel] [shortclassification]"
		E.db.unitframe.units.target.name.xOffset = 0
		E.db.unitframe.units.target.name.yOffset = 6
		E.db.unitframe.units.target.buffs.enable = true
		E.db.unitframe.units.target.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.target.buffs.fontSize = 10
		E.db.unitframe.units.target.buffs.xOffset = 2
		E.db.unitframe.units.target.buffs.yOffset = 1
		E.db.unitframe.units.target.buffs.perrow = 4
		E.db.unitframe.units.target.buffs.sizeOverride = 30
		E.db.unitframe.units.target.buffs.noConsolidated.friendly = true
		E.db.unitframe.units.target.buffs.noConsolidated.enemy = true
		E.db.unitframe.units.target.debuffs.enable = false
		E.db.unitframe.units.target.debuffs.yOffset = -36
		E.db.unitframe.units.target.debuffs.attachTo = "FRAME"
		if E.myclass == "ROGUE" then
			E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.target.combobar.enable = true
			E.db.unitframe.units.target.combobar.autoHide = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0310"
			E.db.unitframe.units.player.buffs.yOffset = -78
		elseif  E.myclass == "DRUID" and tree == 2 then
			E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.target.combobar.enable = true
			E.db.unitframe.units.target.combobar.autoHide = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0310"
			E.db.unitframe.units.player.buffs.yOffset = -78
		elseif  E.myclass == "DRUID" and tree == 1 then
			E.db.unitframe.units.target.combobar.enable = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.player.buffs.yOffset = -65
		elseif  E.myclass == "DRUID" and tree == 3 then
			E.db.unitframe.units.target.combobar.enable = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.player.buffs.yOffset = -65
		elseif  E.myclass == "DRUID" and tree == 4 then
			E.db.unitframe.units.target.combobar.enable = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.player.buffs.yOffset = -65
		elseif E.myclass == "PRIEST" or E.myclass == "DEATHKNIGHT" or E.myclass == "MONK" or E.myclass == "MAGE" or E.myclass == "HUNTER" or E.myclass == "PALADIN" or E.myclass == "WARLOCK" or E.myclass == "WARRIOR" or E.myclass == "SHAMAN" then
			E.db.unitframe.units.target.combobar.enable = false
			E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0389"
			E.db.unitframe.units.player.buffs.yOffset = -65
		end
		E.db.unitframe.units.target.combobar.detachFromFrame = true
		E.db.unitframe.units.target.combobar.fill = "spaced"
		E.db.unitframe.units.target.combobar.detachedWidth = 270
		E.db.unitframe.units.target.combobar.height = 10
		E.db.unitframe.units.target.castbar.enable = true
		E.db.unitframe.units.target.castbar.width = 350
		E.db.unitframe.units.target.castbar.height = 20
		E.db.unitframe.units.target.castbar.icon = true
		E.db.unitframe.units.target.castbar.format = "Remaining"
		E.db.unitframe.units.target.castbar.spark = true
		E.db.unitframe.units.target.castbar.latency = true
		E.db.unitframe.units.target.aurabar.enable = false
		E.db.unitframe.units.target.aurabar.height = 22
		E.db.unitframe.units.target.aurabar.anchorPoint = "BELOW"
		E.db.unitframe.units.target.customTexts = {}
		E.db.unitframe.units.target.customTexts.HP = {}
		E.db.unitframe.units.target.customTexts.HP.font = "Roboto-Black"
		E.db.unitframe.units.target.customTexts.HP.justifyH = "RIGHT"
		E.db.unitframe.units.target.customTexts.HP.fontOutline = "OUTLINE"
		E.db.unitframe.units.target.customTexts.HP.xOffset = 2
		E.db.unitframe.units.target.customTexts.HP.yOffset = -6
		E.db.unitframe.units.target.customTexts.HP.text_format = "[health:current]"
		E.db.unitframe.units.target.customTexts.HP.size = 32
	--ToT
		E.db.unitframe.units.targettarget.enable = true
		E.db.unitframe.units.targettarget.rangeCheck = true
		E.db.unitframe.units.targettarget.debuffs.enable = false
		E.db.unitframe.units.targettarget.width = 66
		E.db.unitframe.units.targettarget.height = 30
		E.db.unitframe.units.targettarget.power.enable = false
		E.db.unitframe.units.targettarget.name.position = "CENTER"
		E.db.unitframe.units.targettarget.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.targettarget.name.yOffset = 0
	--Focus
		E.db.unitframe.units.focus.rangeCheck = true
		E.db.unitframe.units.focus.width = 66
		E.db.unitframe.units.focus.height = 30
		E.db.unitframe.units.focus.power.enable = false
		E.db.unitframe.units.focus.threatStyle = "NONE"
		E.db.unitframe.units.focus.name.position = "CENTER"
		E.db.unitframe.units.focus.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.focus.debuffs.enable = false
		E.db.unitframe.units.focus.castbar.enable = false
	--Pet
		E.db.unitframe.units.pet.width = 66
		E.db.unitframe.units.pet.height = 30
		E.db.unitframe.units.pet.threatStyle = "NONE"
		E.db.unitframe.units.pet.healPrediction = false
		E.db.unitframe.units.pet.power.enable = false
		E.db.unitframe.units.pet.name.text_format = "[name:short]"
		E.db.unitframe.units.pet.buffIndicator.enable = false
	--Boss
		E.db.unitframe.units.boss.enable = true
		E.db.unitframe.units.boss.width = 152
		E.db.unitframe.units.boss.height = 35
		E.db.unitframe.units.boss.health.text_format = "[healthcolor][health:percent]"
		E.db.unitframe.units.boss.health.position = "TOPRIGHT"
		E.db.unitframe.units.boss.power.enable = true
		E.db.unitframe.units.boss.power.position = "BOTTOM"
		E.db.unitframe.units.boss.power.yOffset = -8
		E.db.unitframe.units.boss.name.text_format = "[name:short]"
		E.db.unitframe.units.boss.buffs.enable = false
		E.db.unitframe.units.boss.debuffs.enable = false
		E.db.unitframe.units.boss.castbar.enable = true
		E.db.unitframe.units.boss.castbar.width = 152
	--BodyGuard		
		E.db.unitframe.units.bodyguard.height = 30
		E.db.unitframe.units.bodyguard.width = 66
	--Arena
		E.db.unitframe.units.arena.width = 225
		E.db.unitframe.units.arena.height = 40
		E.db.unitframe.units.arena.health.text_format = "[health:current]"
		E.db.unitframe.units.arena.power.text_format = "[powercolor][power:current]"
		E.db.unitframe.units.arena.name.text_format = "[namecolor][name:medium]"
		E.db.unitframe.units.arena.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.arena.buffs.fontSize = 11
		E.db.unitframe.units.arena.buffs.sizeOverride = 18
		E.db.unitframe.units.arena.buffs.xOffset = 2
		E.db.unitframe.units.arena.buffs.yOffset = 10
		E.db.unitframe.units.arena.debuffs.fontSize = 11
		E.db.unitframe.units.arena.debuffs.sizeOverride = 18
		E.db.unitframe.units.arena.debuffs.xOffset = 2
		E.db.unitframe.units.arena.debuffs.yOffset = -10
		E.db.unitframe.units.arena.castbar.width = 225
		E.db.unitframe.units.arena.castbar.height = 10
		E.db.unitframe.units.arena.castbar.icon = false
		E.db.unitframe.units.arena.castbar.format = ""
		E.db.unitframe.units.arena.castbar.spark = false
	--Party
		E.db.unitframe.units.party.width = 50
		E.db.unitframe.units.party.height = 40
		E.db.unitframe.units.party.threatStyle = "NONE"
		E.db.unitframe.units.party.growthDirection = "LEFT_UP"
		E.db.unitframe.units.party.horizontalSpacing = 2
		E.db.unitframe.units.party.verticalSpacing = 2
		E.db.unitframe.units.party.health.postion = "BOTTOM"
		E.db.unitframe.units.party.health.text_format = ""
		E.db.unitframe.units.party.power.enable = false
		E.db.unitframe.units.party.name.position = "CENTER"
		E.db.unitframe.units.party.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.GPSArrow.enable = false
		E.db.unitframe.units.party.buffIndicator.enable = false
		E.db.unitframe.units.party.roleIcon.enable = false
		E.db.unitframe.units.party.roleIcon.position = "TOPLEFT"
		E.db.unitframe.units.party.debuffs.perrow = 1
		E.db.unitframe.units.party.debuffs.numrows = 3
		E.db.unitframe.units.party.debuffs.sizeOverride = 30
		E.db.unitframe.units.party.debuffs.yOffset = -8
		E.db.unitframe.units.party.debuffs.anchorPoint = "TOP"
		E.db.unitframe.units.party.debuffs.onlyDispellable = false
		E.db.unitframe.units.party.buffs.enable = false
		E.db.unitframe.units.party.buffs.perrow = 2
		E.db.unitframe.units.party.buffs.numrows = 1
		E.db.unitframe.units.party.buffs.sizeOverride = 20
		E.db.unitframe.units.party.buffs.xOffset = -47
		E.db.unitframe.units.party.buffs.yOffset = 0
		E.db.unitframe.units.party.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.party.visibility = "[@raid6,exists][nogroup] hide;show"
		E.db.unitframe.units.party.colorOverride = "USE_DEFAULT"
	--Raid
		E.db.unitframe.units.raid.horizontalSpacing = 2
		E.db.unitframe.units.raid.rdebuffs.enable = false
		E.db.unitframe.units.raid.growthDirection = "LEFT_UP"
		E.db.unitframe.units.raid.name.position = "CENTER"
		E.db.unitframe.units.raid.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.raid.power.enable = false
		E.db.unitframe.units.raid.buffIndicator.enable = false
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid.GPSArrow.enable = false
		E.db.unitframe.units.raid.width = 45
		E.db.unitframe.units.raid.height = 30
		E.db.unitframe.units.raid.health.text_format = ""
		E.db.unitframe.units.raid.healPrediction = false
		E.db.unitframe.units.raid.threatStyle = "NONE"
		E.db.unitframe.units.raid.verticalSpacing = 2
		E.db.unitframe.units.raid.numGroups = 8
		E.db.unitframe.units.raid.visibility = "[@raid6,noexists] hide;show"
		E.db.unitframe.units.raid.colorOverride = "USE_DEFAULT"
	--Other
		E.db.unitframe.units.raid40.enable = false
		E.db.unitframe.units.tank.enable = false
		E.db.unitframe.units.assist.enable = false
	-- Bags
		E.db.bags.bagSize = 34
		E.db.bags.bankSize = 34
		E.db.bags.bagWidth = 473
		E.db.bags.bankWidth = 473
		E.db.bags.alignToChat = false
		E.db.bags.moneyFormat = "BLIZZARD"
		E.db.bags.currencyFormat = "ICON"
	-- Nameplate
		E.db.nameplate.font = "Roboto-Black"
		E.db.nameplate.fontSize = 7
		E.db.nameplate.fontOutline = "OUTLINE"
		E.db.nameplate.targetIndicator = false
		E.db.nameplate.healthBar.width = 108
		E.db.nameplate.healthBar.height = 9
		E.db.nameplate.healthBar.text.enable = false
		E.db.nameplate.buffs.font = "Roboto-Black"
		E.db.nameplate.buffs.fontOutline = "OUTLINE"
		E.db.nameplate.debuffs.font = "Roboto-Black"
		E.db.nameplate.debuffs.fontOutline = "OUTLINE"
		E.db.nameplate.threat.goodColor = {r = 75/255, g = 175/255, b = 76/255}
		E.db.nameplate.threat.badColor = {r = 199/255, g = 64/255, b = 64/255}
		E.db.nameplate.threat.goodTransitionColor = {r = 218/255, g = 197/255, b = 92/255}
		E.db.nameplate.threat.badTransitionColor = {r = 240/255, g = 154/255, b = 17/255}
		E.db.nameplate.reactions.tapped = {r = 153/255, g = 153/255, b = 153/255}
		E.db.nameplate.reactions.friendlyNPC = { r = 79/255, g = 115/255, b = 161/255 }
		E.db.nameplate.reactions.friendlyPlayer = { r = 75/255, g = 175/255, b = 76/255 }
		E.db.nameplate.reactions.neutral = { r = 218/255, g = 197/255, b = 92/255 }
		E.db.nameplate.reactions.enemy = { r = 199/225, g = 64/225, b = 64/225 }
	-- Auras
		E.db.auras.disableBlizzard = true
		E.db.auras.font = "Roboto-Black"
		E.db.auras.fontSize = 12
		E.db.auras.fontOutline = "OUTLINE"
		E.db.auras.consolidatedBuffs.enable = true
		E.db.auras.consolidatedBuffs.font = "Roboto-Black"
		E.db.auras.consolidatedBuffs.fontSize = 10
		E.db.auras.consolidatedBuffs.fontOutline = "OUTLINE"
		E.db.auras.consolidatedBuffs.durations = false
		E.db.auras.buffs.wrapAfter = 12
		E.db.auras.buffs.maxWraps = 2
		E.db.auras.buffs.horizontalSpacing = 2
		E.db.auras.buffs.verticalSpacing = 16
		E.db.auras.buffs.size = 32
		E.db.auras.buffs.seperateOwn = 0
		E.db.auras.debuffs.horizontalSpacing = 3
		E.db.auras.debuffs.wrapAfter = 6
		E.db.auras.debuffs.seperateOwn = 0
		E.db.auras.debuffs.sortDir = "+"
		E.db.auras.debuffs.size = 32
	-- Chat
		E.db.chat.font = "Roboto-Black"
		E.db.chat.fontOutline = "OUTLINE"
		E.db.chat.emotionIcons = false
		E.db.chat.panelWidth = 450
		E.db.chat.separateSizes = false
		E.db.chat.panelHeight = 222
		E.db.chat.panelBackdrop = "HIDEBOTH"
		E.db.chat.panelTabBackdrop = false
		E.db.chat.tabFont = "Roboto-Black"
		E.db.chat.tabFontSize = 12
		E.db.chat.tabFontOutline = "OUTLINE"
		E.db.chat.lfgIcons = false
		E.db.chat.chatHistory = false
		E.db.chat.keywords = "%MYNAME%, ElvUI, TohrUI"
		E.db.chat.timeStampFormat = "NONE"
	-- Data Text
		E.db.datatexts.font = "Roboto-Black"
		E.db.datatexts.fontSize = 11
		E.db.datatexts.fontOutline = "OUTLINE"
		E.db.datatexts.minimapPanels = true
		E.db.datatexts.leftChatPanel = false
		E.db.datatexts.rightChatPanel = false
		E.db.datatexts.panels.LeftChatDataPanel.left = ""
		E.db.datatexts.panels.LeftChatDataPanel.middle = ""
		E.db.datatexts.panels.LeftChatDataPanel.right = ""
		E.db.datatexts.panels.RightChatDataPanel.left = ""
		E.db.datatexts.panels.RightChatDataPanel.middle = ""
		E.db.datatexts.panels.RightChatDataPanel.right = ""
		E.db.datatexts.panels.LeftMiniPanel = ""
		E.db.datatexts.panels.RightMiniPanel = "Time"
		E.db.datatexts.battleground = false
	-- Tooltip
		E.db.tooltip.cursorAnchor = false
		E.db.tooltip.targetInfo = true
		E.db.tooltip.playerTitles = false
		E.db.tooltip.inspectInfo = false
		E.db.tooltip.guildRanks = false
		E.db.tooltip.talentInfo = false
		E.db.tooltip.itemCount = "BOTH"
		E.db.tooltip.spellID = true
		E.db.tooltip.healthBar.height = 0
		E.db.tooltip.healthBar.font = "Roboto-Black"
		E.db.tooltip.healthBar.text = false
		E.db.tooltip.healthBar.fontSize = 12
	-- Cooldown
		E.db.cooldown.threshold = 2
		E.db.cooldown.expiringcolor = { r = 255/255, g = 54/255, b = 54/255 }
		E.db.cooldown.secondscolor = { r = 156/255, g = 255/255, b = 123/255 }
		E.db.cooldown.minutescolor = { r = 1, g = 1, b = 1 }
		E.db.cooldown.hourscolor = { r = 102/225, g = 255/225, b = 255/225 }
		E.db.cooldown.dayscolor = { r = 102/225, g = 102/225, b = 255/225 }
	-- Actionbars
		E.db.actionbar.font = "Roboto-Black"
		E.db.actionbar.movementModifier = "CTRL"
		E.db.actionbar.fontSize = 11
		E.db.actionbar.fontOutline = "OUTLINE"
		E.db.actionbar.hotkeytext = false
		E.db.actionbar.noRangeColor = {r = 204/255, g = 26/255, b = 26/255}
		E.db.actionbar.noPowerColor = {r = 128/255, g = 128/255, b = 255/255}
		E.db.actionbar.microbar.enabled = false
		E.db.actionbar.microbar.mouseover = true
		E.db.actionbar.bar1.mouseover = false
		E.db.actionbar.bar1.buttons = 12
		E.db.actionbar.bar1.buttonsPerRow = 12
		E.db.actionbar.bar1.buttonsize = 26
		E.db.actionbar.bar1.buttonspacing = 2
		E.db.actionbar.bar1.backdrop = false
		E.db.actionbar.bar2.enabled = true
		E.db.actionbar.bar2.mouseover = false
		E.db.actionbar.bar2.buttons = 12
		E.db.actionbar.bar2.buttonsPerRow = 12
		E.db.actionbar.bar2.buttonsize = 26
		E.db.actionbar.bar2.buttonspacing = 2
		E.db.actionbar.bar2.backdrop = false
		E.db.actionbar.bar3.mouseover = true
		E.db.actionbar.bar3.buttons = 12
		E.db.actionbar.bar3.buttonsPerRow = 12
		E.db.actionbar.bar3.buttonsize = 26
		E.db.actionbar.bar3.buttonspacing = 2
		E.db.actionbar.bar3.backdrop = false
		E.db.actionbar.bar4.enabled = false
		E.db.actionbar.bar4.mouseover = true
		E.db.actionbar.bar4.buttons = 12
		E.db.actionbar.bar4.point = "BOTTOMLEFT"
		E.db.actionbar.bar4.buttonsPerRow = 12
		E.db.actionbar.bar4.backdrop = false
		E.db.actionbar.bar4.buttonsize = 26
		E.db.actionbar.bar4.buttonspacing = 2
		E.db.actionbar.bar5.mouseover = false
		E.db.actionbar.bar5.buttons = 8
		E.db.actionbar.bar5.buttonsPerRow = 12
		E.db.actionbar.bar5.buttonsize = 32
		E.db.actionbar.bar5.buttonspacing = 2
		E.db.actionbar.bar5.alpha = 0.8
		E.db.actionbar.bar6.enabled = false
		E.db.actionbar.bar6.buttons = 12
		E.db.actionbar.bar6.buttonsize = 26
		E.db.actionbar.bar6.buttonspacing = 2
		E.db.actionbar.barPet.mouseover = false
		E.db.actionbar.barPet.buttonsize = 28
		E.db.actionbar.barPet.buttonsPerRow = 1
		E.db.actionbar.barPet.buttonspacing = 2
		E.db.actionbar.barPet.backdrop = false
		E.db.actionbar.stanceBar.mouseover = true
		E.db.actionbar.stanceBar.buttonsize = 30
		E.db.actionbar.stanceBar.buttonspacing = 2
		E.db.actionbar.stanceBar.backdrop = false
	-- AuraBars
	elseif theme == "aBars" then
		E.db.unitframe.units.player.aurabar.enable = true
		E.db.unitframe.units.target.aurabar.enable = true
	--Alternate Colors
	elseif theme == "aColors" then
		E.db.unitframe.statusbar = "Tohr_Gradient"
		E.db.unitframe.units.focus.name.text_format = "[name:short]"
		E.db.unitframe.units.targettarget.name.text_format = "[name:short]"
		E.db.unitframe.units.party.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.raid.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.target.name.text_format = "[name:medium] [difficultycolor][smartlevel] [shortclassification]"
		E.db.unitframe.colors.healthclass = true
		E.db.unitframe.colors.powerclass = false
		E.db.unitframe.colors.classbackdrop = false
		E.db.unitframe.colors.customhealthbackdrop = true
		E.db.unitframe.colors.transparentHealth = false
	--DataText
	elseif theme == "dText" then
		E.db.datatexts.leftChatPanel = true
		E.db.datatexts.panels.LeftChatDataPanel.left = "Garrison"
		E.db.datatexts.panels.LeftChatDataPanel.middle = "Gold"
		E.db.datatexts.panels.LeftChatDataPanel.right = "System"
	elseif theme == "hFrame" then
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT748542"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT748542"
	--Raid
		E.db.unitframe.units.raid.rdebuffs.enable = true
		E.db.unitframe.units.raid.growthDirection = "UP_LEFT"
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid.width = 50
		E.db.unitframe.units.raid.height = 40
		E.db.unitframe.units.raid.health.text_format = "[health:deficit]"
		E.db.unitframe.units.raid.healPrediction = true
		E.db.unitframe.units.raid.buffIndicator.enable = true
	--PARTY
		E.db.unitframe.units.party.health.text_format = "[health:deficit]"
		E.db.unitframe.units.party.debuffs.enable = true
		E.db.unitframe.units.party.buffIndicator.enable = true
	elseif theme == "resetStuff" then
	InstallStepComplete.message = L["Settings Reset"]
	InstallStepComplete:Show()
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT1089150"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT189426"
		E.db.unitframe.units.player.aurabar.enable = false
		E.db.unitframe.units.target.aurabar.enable = false
		E.db.unitframe.statusbar = "Tohr_Texture"
	--Color
		E.db.unitframe.colors.healthclass = false
		E.db.unitframe.colors.transparentHealth = true
		E.db.unitframe.colors.powerclass = true
		E.db.unitframe.colors.classbackdrop = true
		E.db.unitframe.colors.customhealthbackdrop = false
		E.db.unitframe.units.focus.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.targettarget.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.party.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.raid.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.target.name.text_format = "[namecolor][name:medium] [difficultycolor][smartlevel] [shortclassification]"
	--Raid
		E.db.unitframe.units.raid.rdebuffs.enable = false
		E.db.unitframe.units.raid.growthDirection = "LEFT_UP"
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid.width = 45
		E.db.unitframe.units.raid.height = 30
		E.db.unitframe.units.raid.health.text_format = " "
		E.db.unitframe.units.raid.healPrediction = false
		E.db.unitframe.units.raid.buffIndicator.enable = false
	--Party
		E.db.unitframe.units.party.width = 50
		E.db.unitframe.units.party.height = 40
		E.db.unitframe.units.party.health.text_format = " "
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.buffIndicator.enable = false
	--DataTexts		
		E.db.datatexts.leftChatPanel = false
		E.db.datatexts.panels.LeftChatDataPanel.left = ""
		E.db.datatexts.panels.LeftChatDataPanel.middle = ""
		E.db.datatexts.panels.LeftChatDataPanel.right = ""
	end
	
	if not noDisplayMsg then
		E:UpdateAll(true)
	end
end

function E:SetupAddon(addon)
	if addon == 'Skada' then
		if IsAddOnLoaded('Skada') then
			E:Print(L["The Default profile for Skada has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			SkadaDB['profiles']["Default"] = {
			["windows"] = {
				{
					["classicons"] = false,
					["barslocked"] = true,
					["enabletitle"] = false,
					["set"] = "total",
					["y"] = -26.9945989809889,
					["barfont"] = "Roboto-Black",
					["title"] = {
						["color"] = {
							["a"] = 1,
							["r"] = 0.443137254901961,
							["g"] = 0.443137254901961,
							["b"] = 0.443137254901961,
						},
						["font"] = "Roboto-Black",
						["borderthickness"] = 0,
						["fontsize"] = 12,
						["height"] = 17,
						["texture"] = "Tohr_Texture",
					},
					["barfontflags"] = "OUTLINE",
					["barcolor"] = {
						["a"] = 0.800000011920929,
						["r"] = 0.443137254901961,
						["g"] = 0.443137254901961,
						["b"] = 0.443137254901961,
					},
					["mode"] = "Damage",
					["bartexture"] = "Tohr_Texture",
					["buttons"] = {
						["menu"] = false,
						["mode"] = false,
						["segment"] = false,
					},
					["barwidth"] = 235.000403689875,
					["point"] = "TOPLEFT",
					["barbgcolor"] = {
						["a"] = 0.0,
						["r"] = 0.337254901960784,
						["g"] = 0.337254901960784,
						["b"] = 0.337254901960784,
					},
					["background"] = {
						["color"] = {
							["a"] = 0,
							["b"] = 0.376470588235294,
							["g"] = 0.376470588235294,
							["r"] = 0.376470588235294,
						},
						["height"] = 144.000022978112,
						["texture"] = "None",
					},
					["x"] = 199.00004780268,
				}, -- [1]
			},
			["icon"] = {
				["hide"] = true,
			},
			["hidesolo"] = true,
			["showranks"] = false,
			["onlykeepbosses"] = true,
			["tooltippos"] = "topright",
			["reset"] = {
				["leave"] = 2,
				["instance"] = 2,
				["join"] = 2,
			},
		}
		else
			E:Print(L["The AddOn Skada is not enabled. Profile not created."])
		end
		
		if IsAddOnLoaded('xCT+') then
			E:Print(L["A profile for xCT has been created. Type /xct. Copy from |cffffff00Tohr UI|r profile."])
			InstallStepComplete:Show()
			xCTSavedDB['profiles']["TohrUI"] = {
			["general"] = {
				["font"] = "Roboto-Black",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["class"] = {
				["font"] = "Roboto-Black",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["frameSettings"] = {
				["clearLeavingCombat"] = true,
				["frameStrata"] = "3LOW",
			},
			["outgoing"] = {
				["Y"] = 47,
				["fontSize"] = 12,
				["fontOutline"] = "2OUTLINE",
				["Height"] = 196,
				["font"] = "Roboto-Black",
				["X"] = 209,
				["Width"] = 128,
			},
			["loot"] = {
				["font"] = "Roboto-Black",
				["fontOutline"] = "2OUTLINE",
				["enabledFrame"] = false,
			},
			["damage"] = {
				["Y"] = -124,
				["fontSize"] = 12,
				["fontOutline"] = "2OUTLINE",
				["font"] = "Roboto-Black",
				["X"] = -208,
			},
			["power"] = {
				["font"] = "Roboto-Black",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["healing"] = {
				["enableRealmNames"] = false,
				["fontSize"] = 12,
				["Width"] = 128,
				["showFriendlyHealers"] = false,
				["font"] = "Roboto-Black",
				["fontOutline"] = "2OUTLINE",
				["Height"] = 196,
				["Y"] = 47,
				["X"] = -208,
			},
			["showStartupText"] = false,
			["spells"] = {
				["showMultistrikeIcons"] = false,
				["mergeDontMergeCriticals"] = false,
				["mergeCriticalsByThemselves"] = true,
				["multistrikeLatency"] = 50,
			},
			["megaDamage"] = {
				["decimalPoint"] = false,
			},
			["critical"] = {
				["Y"] = -124,
				["fontSize"] = 12,
				["fontOutline"] = "2OUTLINE",
				["Height"] = 144,
				["font"] = "Roboto-Black",
				["X"] = 209,
				["Width"] = 128,
			},
			["procs"] = {
				["font"] = "Roboto-Black",
				["enabledFrame"] = false,
				["fontOutline"] = "2OUTLINE",
			},
			["spellFilter"] = {
				["listSpells"] = {
					["159238"] = true,
					["157607"] = true,
					["2823"] = true,
				},
				["filterOutgoingDamageValue"] = 1,
				["filterOutgoingHealingValue"] = 1,
			},
			["frames"] = {
				["general"] = {
					["showLowManaHealth"] = false,
					["megaDamage"] = true,
					["showRepChanges"] = false,
					["showBuffs"] = false,
					["showDispells"] = false,
					["fontOutline"] = "2OUTLINE",
					["showPartyKills"] = false,
					["showDebuffs"] = false,
					["Y"] = 252,
					["font"] = "Roboto-Black",
					["showHonorGains"] = false,
					["showInterrupts"] = false,
					["X"] = 3,
				},
				["power"] = {
					["enabledFrame"] = false,
					["fontOutline"] = "2OUTLINE",
					["Y"] = -230,
					["X"] = 423,
					["font"] = "Roboto-Black",
				},
				["healing"] = {
					["enableRealmNames"] = false,
					["fontSize"] = 14,
					["showFriendlyHealers"] = false,
					["fontOutline"] = "2OUTLINE",
					["showOnlyPetHeals"] = false,
					["enableOverHeal"] = false,
					["insertText"] = "top",
					["Width"] = 207,
					["Y"] = -319,
					["X"] = -243,
					["Height"] = 270,
					["fontJustify"] = "RIGHT",
					["font"] = "Roboto-Black",
				},
				["outgoing"] = {
					["fontSize"] = 16,
					["fontOutline"] = "2OUTLINE",
					["Width"] = 149,
					["Y"] = 152,
					["font"] = "Roboto-Black",
					["Height"] = 294,
					["iconsSize"] = 12,
					["X"] = 475,
				},
				["critical"] = {
					["fontSize"] = 18,
					["secondaryFrame"] = 2,
					["fontOutline"] = "2OUTLINE",
					["critPrefix"] = "|cffff0000*|r",
					["Width"] = 145,
					["fontJustify"] = "LEFT",
					["X"] = 346,
					["critPostfix"] = "|cffff0000*|r",
					["font"] = "Roboto-Black",
					["Y"] = 151,
					["Height"] = 295,
				},
				["procs"] = {
					["fontOutline"] = "2OUTLINE",
					["font"] = "Roboto-Black",
					["enabledFrame"] = false,
				},
				["loot"] = {
					["fontOutline"] = "2OUTLINE",
					["enabledFrame"] = false,
					["font"] = "Roboto-Black",
				},
				["class"] = {
					["fontColor"] = {
					},
					["font"] = "Roboto-Black",
					["enabledFrame"] = false,
					["fontOutline"] = "2OUTLINE",
				},
				["damage"] = {
					["fontSize"] = 14,
					["font"] = "Roboto-Black",
					["Width"] = 207,
					["Y"] = -319,
					["X"] = 240,
					["Height"] = 270,
					["fontOutline"] = "2OUTLINE",
				},
			},
			["dbVersion"] = "4.0.1",
			["blizzardFCT"] = {
				["CombatThreatChanges"] = true,
			},
		}
		else
			E:Print(L["The AddOn xCT is not enabled. Profile not created. Use the |cffffff00Tohr UI|r profile."])
		end
		
		if IsAddOnLoaded('BigWigs') then
			E:Print(L["The Default profile for BigWigs has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			BigWigs3DB = {["namespaces"] = {
				["BigWigs_Plugins_Colors"] = {
				},
				["BigWigs_Plugins_Alt Power"] = {
					["profiles"] = {	
						["Default"] = {
							["posx"] = 1193.95591919313,
							["fontSize"] = 11.999999726451,
							["disabled"] = true,
							["fontOutline"] = "",
							["posy"] = 289.422569014691,
							["font"] = "Roboto-Black",
						},	
					},	
				},
				["BigWigs_Bosses_Brackenspore"] = {
					["profiles"] = {	
						["Default"] = {	
							["living_mushroom"] = 0,
							["rejuvenating_mushroom"] = 0,
							["mind_fungus"] = 0,
							["spore_shooter"] = 0,
						},
					},	
				},
				["BigWigs_Plugins_Bars"] = {
					["profiles"] = {	
						["Default"] = {	
							["BigWigsEmphasizeAnchor_y"] = 344.688889568349,
							["fontSize"] = 12,
							["BigWigsAnchor_width"] = 187.000220959171,
							["BigWigsAnchor_y"] = 31.9998658240379,
							["BigWigsEmphasizeAnchor_x"] = 358.400912435584,
							["barStyle"] = "ElvUI",
							["emphasizeGrowup"] = false,
							["BigWigsAnchor_x"] = 1047.4673291442,
							["outline"] = "OUTLINE",
							["font"] = "Roboto-Black",
							["BigWigsEmphasizeAnchor_width"] = 242.999955616682,
							["emphasizeScale"] = 1.2,
							["texture"] = "Tohr_Texture",
						},
					},
				},
				["BigWigs_Plugins_Super Emphasize"] = {
					["profiles"] = {	
						["Default"] = {
							["font"] = "Roboto-Black",
						},
					},
				},
				["BigWigs_Plugins_Sounds"] = {
					["profiles"] = {	
						["Default"] = {
							["Long"] = {
							},
							["Warning"] = {
							},
							["Info"] = {
							},
							["Alarm"] = {
							},
							["Alert"] = {
							},
						},
					},	
				},
				["BigWigs_Plugins_Statistics"] = {
				},
				["BigWigs_Plugins_Proximity"] = {
					["profiles"] = {	
						["Default"] = {
							["soundDelay"] = 10,
							["fontSize"] = 20.000000273549,
							["disabled"] = true,
							["width"] = 100.000027628445,
							["objects"] = {
								["title"] = false,
								["close"] = false,
								["ability"] = false,
								["tooltip"] = false,
								["background"] = false,
							},
							["font"] = "Roboto-Black",
							["lock"] = true,
							["height"] = 95.9998665081086,
							["posx"] = 354.844387932617,
							["posy"] = 524.799535277143,
						},	
					},
				},
				["BigWigs_Plugins_Raid Icons"] = {
				},
				["BigWigs_Plugins_Messages"] = {
					["profiles"] = {
						["Default"] = {	
							["outline"] = "OUTLINE",
							["BWEmphasizeMessageAnchor_x"] = 609.422280381787,
							["BWEmphasizeCountdownMessageAnchor_x"] = 546.844898719825,
							["BWMessageAnchor_x"] = 609.421716145662,
							["chat"] = false,
							["BWEmphasizeCountdownMessageAnchor_y"] = 335.644016449715,
							["font"] = "Roboto-Black",
							["BWEmphasizeMessageAnchor_y"] = 535.466375813212,
							["BWMessageAnchor_y"] = 535.466506021548,
							["fontSize"] = 20.000000273549,
							["sink20OutputSink"] = "BigWigsEmphasized",
							},	
						},
					},
					["LibDualSpec-1.0"] = {
					},
				},
				["profiles"] = {
					["Default"] = {
						["raidicon"] = false,
					},
				},
			}
			BigWigs3IconDB = {
				["hide"] = true,
			}
		else
			E:Print(L["The AddOn BigWigs is not enabled. Profile not created."])
		end		
	end
end

local function InstallComplete()
	E.private.install_complete = E.version
	
	ReloadUI()
end
		
local function ResetAll()
	InstallNextButton:Disable()
	InstallPrevButton:Disable()
	hFrameBtn:Hide()
	hFrameBtn:SetScript("OnClick", nil)
	hFrameBtn:SetText("")
	aBarsBtn:Hide()
	aBarsBtn:SetScript('OnClick', nil)
	aBarsBtn:SetText('')
	dTextBtn:Hide()
	dTextBtn:SetScript('OnClick', nil)
	dTextBtn:SetText('')	
	aColorsBtn:Hide()
	aColorsBtn:SetScript('OnClick', nil)
	aColorsBtn:SetText('')
	AddOnsBtn:Hide()
	AddOnsBtn:SetScript('OnClick', nil)
	AddOnsBtn:SetText('')
	CVarsBtn:Hide()
	CVarsBtn:SetScript('OnClick', nil)
	CVarsBtn:SetText('')
	SetupChatBtn:Hide()
	SetupChatBtn:SetScript('OnClick', nil)
	SetupChatBtn:SetText('')
	InstallBtn:Hide()
	InstallBtn:SetScript('OnClick', nil)
	InstallBtn:SetText('')
	FinishBtn:Hide()
	FinishBtn:SetScript('OnClick', nil)
	FinishBtn:SetText('')
	ResetBtn:Hide()
	ResetBtn:SetScript('OnClick', nil)
	ResetBtn:SetText('')
	MoveBtn:Hide()
	MoveBtn:SetScript('OnClick', nil)
	MoveBtn:SetText('')
	ElvUIInstallFrame:Size(205, 127)
end

local function SetPage(PageNum)
	CURRENT_PAGE = PageNum
	ResetAll()
	
	local f = ElvUIInstallFrame
	
	if PageNum == 4 then
		InstallNextButton:Hide()
		InstallNextButton:Disable()
		InstallPrevButton:Enable()
		f.Right:Hide()
		FinishBtn:Show()	
	else
		FinishBtn:Hide()
		f.Right:Show()
		InstallNextButton:Show()
		InstallNextButton:Enable()
	end
	
	if PageNum == 1 then
		InstallPrevButton:Hide()
		InstallPrevButton:Disable()
		f.Left:Hide()
		f.InstallBtn:Show()
	else
		f.InstallBtn:Hide()
		f.Left:Show()	
		InstallPrevButton:Show()
		InstallPrevButton:Enable()
	end
	
	if PageNum == 2 then
		f.ResetBtn:Show()
	else
		f.ResetBtn:Hide()
	end
	
	

	if PageNum == 1 then
		InstallBtn:Show()
		InstallBtn:SetScript('OnClick', function() E:SetupTheme('TohrUI') end)
		InstallBtn:SetText(L['|cff00FF96Install'])	
		MoveBtn:Show()
		MoveBtn:SetScript("OnClick", function() E:ToggleConfigMode() end)
		MoveBtn:SetText(L['|cffFFFFFFU'])
	elseif PageNum == 2 then
		hFrameBtn:Show()
		hFrameBtn:SetScript('OnClick', function() E:SetupTheme('hFrame') end)
		hFrameBtn:SetText(L['|cff69CCF0Healer Frames'])
		aBarsBtn:Show()
		aBarsBtn:SetScript('OnClick', function() E:SetupTheme('aBars') end)
		aBarsBtn:SetText(L['|cff69CCF0Aura Bars'])
		dTextBtn:Show()
		dTextBtn:SetScript('OnClick', function() E:SetupTheme('dText') end)
		dTextBtn:SetText(L['|cff69CCF0Data Texts'])
		aColorsBtn:Show()
		aColorsBtn:SetScript('OnClick', function() E:SetupTheme('aColors') end)
		aColorsBtn:SetText(L['|cff69CCF0Alternate Colors'])	
		ResetBtn:Show()
		ResetBtn:SetScript('OnClick', function() E:SetupTheme('resetStuff') end)
		ResetBtn:SetText(L[''])
		MoveBtn:Show()
		MoveBtn:SetScript("OnClick", function() E:ToggleConfigMode() end)
		MoveBtn:SetText(L['|cffFFFFFFU'])
	elseif PageNum == 3 then
		AddOnsBtn:Show()
		AddOnsBtn:SetScript("OnClick", function() E:SetupAddon('Skada') end)
		AddOnsBtn:SetText(L["|cffFF7D0AAddOns"])
		CVarsBtn:Show()
		CVarsBtn:SetScript("OnClick", SetupCVars)
		CVarsBtn:SetText(L["|cffFF7D0AInterface"])	
		SetupChatBtn:Show()
		SetupChatBtn:SetScript("OnClick", SetupChat)
		SetupChatBtn:SetText(L["|cffFF7D0AChat"])
		MoveBtn:Show()
		MoveBtn:SetScript("OnClick", function() E:ToggleConfigMode() end)
		MoveBtn:SetText(L['|cffFFFFFFU'])
		ElvUIInstallFrame:Size(205, 96)
	elseif PageNum == 4 then
		FinishBtn:Show()
		FinishBtn:SetScript("OnClick", InstallComplete)
		FinishBtn:SetText(L["|cff00FF96Finished"])
		MoveBtn:Show()
		MoveBtn:SetScript("OnClick", function() E:ToggleConfigMode() end)
		MoveBtn:SetText(L['|cffFFFFFFU'])
	end
end

local function NextPage()	
	if CURRENT_PAGE ~= MAX_PAGE then
		CURRENT_PAGE = CURRENT_PAGE + 1
		SetPage(CURRENT_PAGE)
	end
end

local function PreviousPage()
	if CURRENT_PAGE ~= 1 then
		CURRENT_PAGE = CURRENT_PAGE - 1
		SetPage(CURRENT_PAGE)
	end
end

--Install UI
function E:Install()	
	if not InstallStepComplete then
		local imsg = CreateFrame("Frame", "InstallStepComplete", E.UIParent)
		imsg:Size(206, 150)
		imsg:Point("TOP", 0, -190)
		imsg:Hide()
		imsg:SetScript('OnShow', function(self)
			if self.message then 
				self.text:SetText(self.message)
				UIFrameFadeOut(self, 3.5, 1, 0)
				E:Delay(4, function() self:Hide() end)	
				self.message = nil

				if imsg.firstShow == false then			
					imsg.firstShow = true
				end
			else
				self:Hide()
			end
		end)

		imsg.firstShow = false

		imsg.bg = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.bg:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.bg:SetPoint('BOTTOM')
		imsg.bg:Size(206, 150)
		imsg.bg:SetTexCoord(0.00195313, 0.63867188, 0.03710938, 0.23828125)
		imsg.bg:SetVertexColor(1, 1, 1, 0.6)


		imsg.lineBottom = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineBottom:SetDrawLayer('BACKGROUND', 2)
		imsg.lineBottom:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineBottom:SetPoint("BOTTOM")
		imsg.lineBottom:Size(206, 150)
		imsg.lineBottom:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.text = imsg:CreateFontString(nil, 'ARTWORK', 'GameFont_Gigantic')
		imsg.text:Point("BOTTOM", 0, 12)
		imsg.text:SetTextColor(1, 0.82, 0)
		imsg.text:SetJustifyH("CENTER")
		
	end

	--Create Frame
	if not ElvUIInstallFrame then
		local f = CreateFrame("Button", "ElvUIInstallFrame", E.UIParent)
		f.SetPage = SetPage
		f:Size(206, 150)
		f:SetTemplate("Transparent")
		f:SetPoint("CENTER")
		f:SetFrameStrata('LOW')
		
		f.Next = CreateFrame("Button", "InstallNextButton", f, "UIPanelButtonTemplate")
		f.Next:StripTextures()
		f.Next:SetTemplate("Default", true)
		f.Next:SetAlpha(0)
		f.Next:Size(32, 32)
		f.Next:Point("RIGHT", 64, 0)
		f.Next:Disable()
		f.Next:SetScript("OnClick", NextPage)
		E.Skins:HandleButton(f.Next, true)
		
		f.Prev = CreateFrame("Button", "InstallPrevButton", f, "UIPanelButtonTemplate")
		f.Prev:StripTextures()
		f.Prev:SetTemplate("Default", true)
		f.Prev:SetAlpha(0)
		f.Prev:Size(32, 32)
		f.Prev:Point("LEFT", -64, 0)
		f.Prev:Disable()
		f.Prev:SetScript("OnClick", PreviousPage)
		E.Skins:HandleButton(f.Prev, true)
		
		f.hFrame = CreateFrame("Button", "hFrameBtn", f, "UIPanelButtonTemplate")
		f.hFrame:StripTextures()
		f.hFrame:Size(125, 30)
		f.hFrame:Point("BOTTOM", 0, 2)
		f.hFrame:SetText("")
		f.hFrame:Hide()
		E.Skins:HandleButton(f.hFrame, true)
		
		f.aBars = CreateFrame("Button", "aBarsBtn", f, "UIPanelButtonTemplate")
		f.aBars:StripTextures()
		f.aBars:Size(125, 30)
		f.aBars:Point('BOTTOM', 0, 33)
		f.aBars:SetText("")
		f.aBars:Hide()
		E.Skins:HandleButton(f.aBars, true)		
		
		f.dText = CreateFrame("Button", "dTextBtn", f, "UIPanelButtonTemplate")
		f.dText:StripTextures()
		f.dText:Size(125, 30)
		f.dText:Point("BOTTOM", 0, 64)
		f.dText:SetText("")
		f.dText:Hide()
		E.Skins:HandleButton(f.dText, true)	
		
		f.aColors = CreateFrame("Button", "aColorsBtn", f, "UIPanelButtonTemplate")
		f.aColors:StripTextures()
		f.aColors:Size(125, 30)
		f.aColors:Point("BOTTOM", 0, 95)
		f.aColors:SetText("")
		E.Skins:HandleButton(f.aColors, true)
		
		f.AddOns = CreateFrame("Button", "AddOnsBtn", f, "UIPanelButtonTemplate")
		f.AddOns:StripTextures()
		f.AddOns:Size(125, 30)
		f.AddOns:Point('BOTTOM', 0, 2)
		f.AddOns:SetText("")
		E.Skins:HandleButton(f.AddOns, true)
		
		f.CVars = CreateFrame("Button", "CVarsBtn", f, "UIPanelButtonTemplate")
		f.CVars:StripTextures()
		f.CVars:Size(125, 30)
		f.CVars:Point("BOTTOM", 0, 33)
		f.CVars:SetText("")
		E.Skins:HandleButton(f.CVars, true)
		
		f.SetupChat = CreateFrame("Button", "SetupChatBtn", f, "UIPanelButtonTemplate")
		f.SetupChat:StripTextures()
		f.SetupChat:Size(125, 30)
		f.SetupChat:Point("BOTTOM", 0, 64)
		f.SetupChat:SetText("")
		E.Skins:HandleButton(f.SetupChat, true)
		
		f.InstallBtn = CreateFrame("Button", "InstallBtn", f, "UIPanelButtonTemplate")
		f.InstallBtn:StripTextures()
		f.InstallBtn:SetAlpha(1)
		f.InstallBtn:SetFrameStrata('MEDIUM')
		f.InstallBtn:Size(125, 35)
		f.InstallBtn:Point("CENTER", 0, 0)
		f.InstallBtn:SetText("")
		E.Skins:HandleButton(f.InstallBtn, true)
		
		f.FinishBtn = CreateFrame("Button", "FinishBtn", f, "UIPanelButtonTemplate")
		f.FinishBtn:StripTextures()
		f.FinishBtn:SetAlpha(1)
		f.FinishBtn:Size(125, 35)
		f.FinishBtn:Point("CENTER", 0, 0)
		f.FinishBtn:SetText("")
		E.Skins:HandleButton(f.FinishBtn, true)
		
		f.ResetBtn = CreateFrame("Button", "ResetBtn", f, "UIPanelButtonTemplate")
		f.ResetBtn:StripTextures()
		f.ResetBtn:SetAlpha(0)
		f.ResetBtn:Size(125, 30)
		f.ResetBtn:Point("BOTTOM", 0, -31)
		f.ResetBtn:SetText("")
		E.Skins:HandleButton(f.ResetBtn, true)
		
		f.MoveBtn = CreateFrame("Button", "MoveBtn", f, "UIPanelButtonTemplate")
		f.MoveBtn:StripTextures()
		f.MoveBtn:SetFrameStrata('MEDIUM')
		f.MoveBtn:Size(16, 16)
		f.MoveBtn:Point("BOTTOMLEFT", f, "BOTTOMLEFT", 2, 2)
		f.MoveBtn:SetText("")
		f.MoveBtn:SetAlpha(1)
		E.Skins:HandleButton(f.MoveBtn, true)
		
		local close = CreateFrame("Button", "InstallCloseButton", f, "UIPanelCloseButton")
		close:SetAlpha(1)
		close:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 6, -6)
		close:SetScript("OnClick", function()
			f:Hide()
		end)
		E.Skins:HandleCloseButton(close)
		
		f.Logo = f:CreateTexture('Logo', 'OVERLAY')
		f.Logo:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\TohrUI.tga')
		f.Logo:Point('TOP', 0, 115)
		
		f.ResetBtn = f:CreateTexture('ResetButton', 'OVERLAY')
		f.ResetBtn:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\reset.tga')
		f.ResetBtn:Point("BOTTOM", "ElvUIInstallFrame", 0, -50)
		
		f.Left = f:CreateTexture('arrowLeftImage', 'OVERLAY')
		f.Left:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowLeft.tga')
		f.Left:Point('LEFT', "ElvUIInstallFrame", -60, 0)
		
		f.Right = f:CreateTexture('arrowRightImage', 'OVERLAY')
		f.Right:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowRight.tga')
		f.Right:Point('RIGHT', "ElvUIInstallFrame", 60, 0)
		
	end
	
	ElvUIInstallFrame:Show()
	NextPage()
end